	; IntyBASIC compiler v0.2 Feb/03/2014
        ;
        ; Prologue for IntyBASIC programs
        ; by Oscar Toledo G.  http://nanochess.org/
        ;
        ; Revision: Jan/30/2014. Spacing adjustment and more comments.

        ROMW 16
        ORG $5000
        
        ;
        ; ROM header
        ;
        BIDECLE _ZERO           ; MOB picture base
        BIDECLE _ZERO           ; Process table
        BIDECLE _MAIN           ; Program start
        BIDECLE _ZERO           ; Background base image
        BIDECLE _ONES           ; GRAM
        BIDECLE _TITLE          ; Cartridge title and date
        DECLE   $03C0           ; No ECS title, inits code after title,
                                ; ... no clicks
                                
_ZERO:  DECLE   $0000           ; Border control
        DECLE   $0000           ; 0 = color stack, 1 = f/b mode
        
_ONES:  DECLE   $0001, $0001    ; Initial color stack 0 and 1: Blue
        DECLE   $0001, $0001    ; Initial color stack 2 and 3: Blue
        DECLE   $0001           ; Initial border color: Blue

C_WHT:  EQU $0007

CLRSCR: MVII #$200,R4           ; Used also for CLS
        MVII #$F0,R1
FILLZERO:
        CLRR R0
MEMSET:
        MVO@ R0,R4
        DECR R1
        BNE MEMSET
        JR R5

        ;
        ; Title, avoid and jump directly into main program
        ;
_TITLE: PROC
        BYTE    114, 'IntyBASIC program', 0
;        BEGIN

;        RETURN                  ; Return to EXEC for title screen display
        ENDP

        ;
        ; Main program
        ;
_MAIN:
        DIS
        MVII #STACK,R6

_MAIN0:
        ;
        ; Clean memory
        ;
        MVII #$0fe,R1           ; 240 words of 8 bits plus 14 of sound
        MVII #$100,R4           ; 8-bit scratch RAM
        CALL FILLZERO
        MVII #$040,R1           ; 64 words of 16 bits
        MVII #$320,R4           ; 16-bit scratch RAM
        CALL FILLZERO

        CALL CLRSCR             ; Clean up screen

        MVII #_int_vector,R0 ; Points to interrupt vector
        MVO R0,ISRVEC
        SWAP R0
        MVO R0,ISRVEC+1
        MVII #2,R0
        MVO R0,_first_time

        EIS
        MVII #7,R0
        MVO R0,_color           ; Default color for PRINT "string"
        MVII #$038,R0
        MVO R0,$01F8            ; Configures sound
	; 	REM
	; 	REM Shooting letters game
	; 	REM Demo for IntyBASIC
	; 	REM by Oscar Toledo G. http://nanochess.org
	; 	REM Jan/27/2014.
	; 	REM
	; 
	; 	X = 10
	MVII #10,R0
	MVO R0,V1
	; 	S = 0
	CLRR R0
	MVO R0,V2
	; 	PRINT AT 220,"--------------------"
	MVII #732,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVII #104,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO@ R0,R4
	MVO R4,_screen
	; 	GOSUB update_score
	CALL Q1
	; 
	; 	WAVE = 1
	MVII #1,R0
	MVO R0,V3
	; 	STATE = 0
	CLRR R0
	MVO R0,V4
	; 
	; loop:	WAIT
	; LOOP
Q2:		CALL _wait
	; 	IF BY THEN SOUND 0,200-BY*10,15 ELSE SOUND 0,,0
	MVI V5,R0
	TSTR R0
	BEQ T1
	MVII #200,R0
	MVI V5,R1
	MVII #9,R4
	MOVR R1,R5
T2:
	ADDR R5,R1
	DECR R4
	BNE T2
	SUBR R1,R0
	MVO R0,$01f0
	SWAP R0
	MVO R0,$01f4
	MVII #15,R0
	MVO R0,$01fb
	B T3
T1:
	CLRR R0
	MVO R0,$01fb
T3:
	; 	PRINT AT 200+X," "
	MVII #200,R0
	ADD V1,R0
	ADDI #512,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	IF BY THEN PRINT AT BY*20+BX," ":BY=BY-1
	MVI V5,R0
	TSTR R0
	BEQ T4
	MVI V5,R0
	MVII #19,R4
	MOVR R0,R5
T5:
	ADDR R5,R0
	DECR R4
	BNE T5
	ADD V6,R0
	ADDI #512,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	MVI V5,R0
	DECR R0
	MVO R0,V5
T4:
	; 	IF EY THEN PRINT AT EY*20+EX," "
	MVI V7,R0
	TSTR R0
	BEQ T6
	MVI V7,R0
	MVII #19,R4
	MOVR R0,R5
T7:
	ADDR R5,R0
	DECR R4
	BNE T7
	ADD V8,R0
	ADDI #512,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
T6:
	; 	IF FRAME AND 1 THEN GOSUB move_player
	MVI _frame,R0
	ANDI #1,R0
	TSTR R0
	BEQ T8
	CALL Q3
T8:
	;         IF FRAME AND 1 THEN GOSUB enemy
	MVI _frame,R0
	ANDI #1,R0
	TSTR R0
	BEQ T9
	CALL Q4
T9:
	; 	PRINT AT 200+X COLOR 5,"A"
	MVII #200,R0
	ADD V1,R0
	ADDI #512,R0
	MVO R0,_screen
	MVII #5,R0
	MVO R0,_color
	MVI _screen,R4
	MVII #264,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	; 	IF EY THEN PRINT AT EY*20+EX COLOR 3,"E"
	MVI V7,R0
	TSTR R0
	BEQ T10
	MVI V7,R0
	MVII #19,R4
	MOVR R0,R5
T11:
	ADDR R5,R0
	DECR R4
	BNE T11
	ADD V8,R0
	ADDI #512,R0
	MVO R0,_screen
	MVII #3,R0
	MVO R0,_color
	MVI _screen,R4
	MVII #296,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
T10:
	; 	IF BY THEN PRINT AT BY*20+BX COLOR 7,"^"
	MVI V5,R0
	TSTR R0
	BEQ T12
	MVI V5,R0
	MVII #19,R4
	MOVR R0,R5
T13:
	ADDR R5,R0
	DECR R4
	BNE T13
	ADD V6,R0
	ADDI #512,R0
	MVO R0,_screen
	MVII #7,R0
	MVO R0,_color
	MVI _screen,R4
	MVII #496,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
T12:
	; 	IF BY=EY AND BX=EX AND BY<>0 THEN GOSUB add_points
	MVI V5,R0
	CMP V7,R0
	MVII #1,R0
	BEQ T15
	DECR R0
T15:
	MVI V6,R1
	CMP V8,R1
	MVII #1,R1
	BEQ T16
	DECR R1
T16:
	ANDR R1,R0
	MVI V5,R1
	CMPI #0,R1
	MVII #1,R1
	BNE T17
	DECR R1
T17:
	ANDR R1,R0
	TSTR R0
	BEQ T14
	CALL Q5
T14:
	; 	GOTO loop
	B Q2
	; 
	; update_score:	PROCEDURE
	; UPDATE_SCORE
Q1:	PROC
	BEGIN
	; 	PRINT AT 0,"Score: ",(S/100%10+16)*8+6,(S/10%10+16)*8+6,(S%10+16)*8+6
	MVII #512,R0
	MVO R0,_screen
	MVI _screen,R4
	MVII #408,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #536,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #632,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #656,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #552,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #208,R0
	XOR _color,R0
	MVO@ R0,R4
	MVII #0,R0
	XOR _color,R0
	MVO@ R0,R4
	MVO R4,_screen
	MVI V2,R0
	MVII #-1,R4
T18:
	INCR R4
	SUBI #100,R0
	BC T18
	MOVR R4,R0
T19:
	SUBI #10,R0
	BC T19
	ADDI #10,R0
	ADDI #16,R0
	SLL R0,2
	SLL R0,1
	ADDI #6,R0
	MVI _screen,R4
	MVO@ R0,R4
	MVO R4,_screen
	MVI V2,R0
	MVII #-1,R4
T20:
	INCR R4
	SUBI #10,R0
	BC T20
	MOVR R4,R0
T21:
	SUBI #10,R0
	BC T21
	ADDI #10,R0
	ADDI #16,R0
	SLL R0,2
	SLL R0,1
	ADDI #6,R0
	MVI _screen,R4
	MVO@ R0,R4
	MVO R4,_screen
	MVI V2,R0
T22:
	SUBI #10,R0
	BC T22
	ADDI #10,R0
	ADDI #16,R0
	SLL R0,2
	SLL R0,1
	ADDI #6,R0
	MVI _screen,R4
	MVO@ R0,R4
	MVO R4,_screen
	; 	END
	RETURN
	ENDP
	; 
	; move_player:	PROCEDURE
	; MOVE_PLAYER
Q3:	PROC
	BEGIN
	; 	IF cont1.left THEN IF X>0 THEN X=X-1
	MVI 511,R0
	COMR R0
	ANDI #8,R0
	TSTR R0
	BEQ T23
	MVI V1,R0
	CMPI #0,R0
	BLE T24
	MVI V1,R0
	DECR R0
	MVO R0,V1
T24:
T23:
	; 	IF cont1.right THEN IF X<19 THEN X=X+1
	MVI 511,R0
	COMR R0
	ANDI #2,R0
	TSTR R0
	BEQ T26
	MVI V1,R0
	CMPI #19,R0
	BGE T27
	MVI V1,R0
	INCR R0
	MVO R0,V1
T27:
T26:
	; 	IF cont1.button THEN IF BY=0 THEN BY=10:BX=X
	MVI 511,R0
	COMR R0
	ANDI #224,R0
	TSTR R0
	BEQ T29
	MVI V5,R0
	CMPI #0,R0
	BNE T30
	MVII #10,R0
	MVO R0,V5
	MVI V1,R0
	MVO R0,V6
T30:
T29:
	; 	RETURN
	RETURN
	; 	END
	RETURN
	ENDP
	; 
	; enemy:	PROCEDURE
	; ENEMY
Q4:	PROC
	BEGIN
	; 	IF STATE=1 GOTO move_enemy
	MVI V4,R0
	CMPI #1,R0
	BNE T32
	B Q9
T32:
	; 	EY = (WAVE AND 7) + 1
	MVI V3,R0
	ANDI #7,R0
	INCR R0
	MVO R0,V7
	; 	IF WAVE AND 1 THEN EX=19 ELSE EX=0
	MVI V3,R0
	ANDI #1,R0
	TSTR R0
	BEQ T34
	MVII #19,R0
	MVO R0,V8
	B T35
T34:
	CLRR R0
	MVO R0,V8
T35:
	; 	STATE=1
	MVII #1,R0
	MVO R0,V4
	; 	RETURN
	RETURN
	; 
	; move_enemy:	
	; MOVE_ENEMY
Q9:	; 	IF WAVE AND 1 THEN IF EX=0 THEN STATE=0:EY=0:WAVE=WAVE+1 ELSE EX=EX-1
	MVI V3,R0
	ANDI #1,R0
	TSTR R0
	BEQ T36
	MVI V8,R0
	CMPI #0,R0
	BNE T37
	CLRR R0
	MVO R0,V4
	CLRR R0
	MVO R0,V7
	MVI V3,R0
	INCR R0
	MVO R0,V3
	B T39
T37:
	MVI V8,R0
	DECR R0
	MVO R0,V8
T39:
T36:
	; 	IF NOT WAVE AND 1 THEN IF EX=19 THEN STATE=0:EY=0:WAVE=WAVE+1 ELSE EX=EX+1
	MVI V3,R0
	COMR R0
	ANDI #1,R0
	TSTR R0
	BEQ T40
	MVI V8,R0
	CMPI #19,R0
	BNE T41
	CLRR R0
	MVO R0,V4
	CLRR R0
	MVO R0,V7
	MVI V3,R0
	INCR R0
	MVO R0,V3
	B T43
T41:
	MVI V8,R0
	INCR R0
	MVO R0,V8
T43:
T40:
	; 	END
	RETURN
	ENDP
	; 
	; add_points:	PROCEDURE
	; ADD_POINTS
Q5:	PROC
	BEGIN
	; 	EY=0:STATE=0:S=S+1:GOSUB update_score
	CLRR R0
	MVO R0,V7
	CLRR R0
	MVO R0,V4
	MVI V2,R0
	INCR R0
	MVO R0,V2
	CALL Q1
	; 	SOUND 1,400,14
	MVII #400,R0
	MVO R0,$01f1
	SWAP R0
	MVO R0,$01f5
	MVII #14,R0
	MVO R0,$01fc
	; 	WAIT
	CALL _wait
	; 	SOUND 1,300,14
	MVII #300,R0
	MVO R0,$01f1
	SWAP R0
	MVO R0,$01f5
	MVII #14,R0
	MVO R0,$01fc
	; 	WAIT
	CALL _wait
	; 	SOUND 1,500,14
	MVII #500,R0
	MVO R0,$01f1
	SWAP R0
	MVO R0,$01f5
	MVII #14,R0
	MVO R0,$01fc
	; 	WAIT
	CALL _wait
	; 	SOUND 1,,0 ' Turn volume to zero
	CLRR R0
	MVO R0,$01fc
	; 	END
	RETURN
	ENDP
	; 
        ;
        ; Epilogue for IntyBASIC programs
        ; by Oscar Toledo G.  http://nanochess.org/
        ;
        ; Revision: Jan/30/2014. Moved GRAM code below MOB updates.
        ;                        Added comments.

        ;
        ; Wait for interruption
        ;
_wait:  PROC
        CLRR    R0
        MVO     R0,_int         ; Clears waiting flag
@@1:    CMP     _int,  R0       ; Waits for change
        BEQ     @@1
        JR      R5              ; Returns
        ENDP

        ;
        ; Interruption routine
        ;
_int_vector:     PROC
        BEGIN

        MVO     R0,     $20     ; Activates display
        MVI     $21,    R0      ; Activates mode for 64 definitions of MOB
        MVII    #1,     R0
        MVO     R0,     _int    ; Indicates interrupt happened
        MVI _first_time,R0
        TSTR R0
        BEQ @@vi0
        DECR R0
        MVO R0,_first_time
        MVII    #0,     R0
        MVO     R0,     $28     ; Color stack 0
        MVO     R0,     $2A     ; Color stack 2
        MVO     R0,     $2C     ; Border color
@@vi0:
        ;
        ; Save collision registers for further use
        ;
        MVI     $18,R0
        MVO     R0,_col0
        MVI     $19,R0
        MVO     R0,_col1
        MVI     $1A,R0
        MVO     R0,_col2
        MVI     $1B,R0
        MVO     R0,_col3
        MVI     $1C,R0
        MVO     R0,_col4
        MVI     $1D,R0
        MVO     R0,_col5
        MVI     $1E,R0
        MVO     R0,_col6
        MVI     $1F,R0
        MVO     R0,_col7
        CLRR    R0
        MVO 	R0,$18
        MVO 	R0,$19
        CLRR    R0
        MVO     R0,$1A
        MVO     R0,$1B
        CLRR    R0
        MVO     R0,$1C
        MVO     R0,$1D
        CLRR    R0
        MVO 	R0,$1E
        MVO     R0,$1F

        ;
        ; Updates sprites (MOBs)
        ;
        MVII #_mobs,R4
        MVII #$0,R5     ; X-coordinates
        MVII #8,R1
@@vi2:  MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        DECR R1
        BNE @@vi2

        ;
        ; Detect GRAM definition
        ;
        MVI _load_gram,R0
        TSTR R0
        BEQ @@vi1
        CLRR R0
        MVO R0,_load_gram
        MVI _gram_bitmap,R4
        MVI _gram_target,R1
        SLL R1,2
        SLL R1,1
        ADDI #$3800,R1
        MOVR R1,R5
        MVI _gram_total,R0
@@vi3:
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        DECR R0
        BNE @@vi3
@@vi1:
        ;
        ; Random number generator
        ;
MACRO _ROR
	RRC R0,1
	MOVR R0,R1
	SLR R1,2
	SLR R1,2
	ANDI #$0800,R1
	SLR R1,2
	SLR R1,2
	ANDI #$007F,R0
	XORR R1,R0
ENDM
        MVI _rand,R0
        SETC
        _ROR
        XOR _frame,R0
        _ROR
        XOR _rand,R0
        _ROR
        XORI #9,R0
        MVO R0,_rand

        ; Increase frame number
        MVI _frame,R0
        INCR R0
        MVO R0,_frame

        RETURN
        ENDP
    
        ORG $330,$330,"-RWB"
        ;
        ; 16-bits variables
        ;
_frame:     RMB 1       ; Current frame
_read:      RMB 1       ; Pointer to DATA
_gram_bitmap:   RMB 1   ; Bitmap for definition
_screen:    RMB 1       ; Pointer to current screen position
_color:     RMB 1       ; Current color
_mobs:      RMB 3*8     ; MOB buffer
_col0:      RMB 1       ; Collision status for MOB0
_col1:      RMB 1       ; Collision status for MOB1
_col2:      RMB 1       ; Collision status for MOB2
_col3:      RMB 1       ; Collision status for MOB3
_col4:      RMB 1       ; Collision status for MOB4
_col5:      RMB 1       ; Collision status for MOB5
_col6:      RMB 1       ; Collision status for MOB6
_col7:      RMB 1       ; Collision status for MOB7

SCRATCH:    ORG $100,$100,"-RWBN"
        ;
        ; 8-bits variables
        ;
ISRVEC:     RMB 2       ; Pointer to ISR vector (require by Intellivision ROM)
_int:       RMB 1       ; Signals interrupt received
_rand:      RMB 1       ; Pseudo-random value
_load_gram: RMB 1       ; Signals GRAM definition waiting
_gram_target:   RMB 1   ; Contains GRAM card number
_gram_total:    RMB 1   ; Contains total GRAM cards for definition
_first_time:    RMB 1   ; Signals program started for first time
V6:	RMB 1	; BX
V5:	RMB 1	; BY
V8:	RMB 1	; EX
V7:	RMB 1	; EY
V2:	RMB 1	; S
V4:	RMB 1	; STATE
V3:	RMB 1	; WAVE
V1:	RMB 1	; X
_SCRATCH:	EQU $

SYSTEM:	ORG $2F0, $2F0, "-RWBN"
STACK:	RMB 32
_SYSTEM:	EQU $
